/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.94 by jmc, Thu Sep 6 22:31:45 2007 UTC revision 1.112 by jmc, Sat Feb 9 18:30:25 2008 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
23      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
24      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 73  build_mpack() Line 74  build_mpack()
74              echo              echo
75              HAVE_MPACK=f              HAVE_MPACK=f
76          fi          fi
         printf "building mpack...  "  
77          if test "x$CC" = x ; then          if test "x$CC" = x ; then
78              export CC=cc              export CC=cc
79          fi          fi
80            printf "building mpack (using CC=$CC)...  "
81          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
82          RETVAL=$?          RETVAL=$?
83          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 88  build_mpack()
88          else          else
89              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
90              HAVE_MPACK=t              HAVE_MPACK=t
91                echo "OK"
92          fi          fi
93      else      else
94          HAVE_MPACK=t          HAVE_MPACK=t
95            echo "done"
96      fi      fi
     echo "OK"  
97  }  }
98    
99  testoutput_var()  testoutput_var()
100  {  {
101      # testoutput_var dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
102      #      #
103      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
104      #     with same output from reference file $dir/results/output.$extension      #     with same output from reference file $dir/results/$reference_output
105      #  using search strings s1 and text label      #  using search strings s1 and text label
106    
107      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 108  testoutput_var() Line 110  testoutput_var()
110      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
111          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
112          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
113          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
114              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
115                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
116              fi              fi
# Line 119  testoutput_var() Line 121  testoutput_var()
121          return 99          return 99
122      fi      fi
123      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
124          echo testoutput_var: grep "$2" $1/results/output.$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
125      fi      fi
126      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
127      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
128      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
129          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
130              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
131          fi          fi
# Line 161  testoutput_var() Line 163  testoutput_var()
163      digits_of_similarity=`./tr_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
164      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
165          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
166              echo testoutput_var: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
167          fi          fi
168          digits_of_similarity=99          digits_of_similarity=99
169      else      else
170          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
171              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
172          fi          fi
173      fi      fi
174      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 174  testoutput_var() Line 176  testoutput_var()
176      return $digits_of_similarity      return $digits_of_similarity
177  }  }
178    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tr_cmpnum < t5.txt`  
     digits_6=`./tr_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
179  check_for_add_mon_output()  check_for_add_mon_output()
180  {  {
181      # Check for additional types of monitor output      # Check for additional types of monitor output
# Line 232  check_for_add_mon_output() Line 203  check_for_add_mon_output()
203    
204  testoutput_run()  testoutput_run()
205  {  {
206      # testoutput_run directory subdir extension      # testoutput_run directory subdir reference_output
207      #      #
208      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
209      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
210          # default list of output variables to be checked:          # default list of output variables to be checked:
211          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
212          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
213          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
         nbDef=`echo $listChk | awk '{print NF-1+3*gsub("+","E")}'`  
214          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
215          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
216          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
217          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
218          listVar=`echo $listChk | awk '{ for(i=2;i<=NF;i++){if (sub("+","",$i)) \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
219              {printf " %s %s %s %s",$i"mn",$i"mx",$i"av",$i"sd"} else {printf " %s",$i} }}'`                                 | sed 's/+//g' | sed "s/^$sVar//"`
220          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
221          for ii in 1 2 3 4 5 6 7 8 9 ; do          for ii in 1 2 3 4 5 6 7 8 9 ; do
222            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
# Line 269  testoutput_run() Line 239  testoutput_run()
239            case $xx in            case $xx in
240             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
241                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
242                    testoutput_var $1 "cg2d_init_res" "cg2d init. residual" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
243                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
244             'Tmn') testoutput_var $1 "dynstat_theta_min"  "theta minimum"  $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
245             'Tmx') testoutput_var $1 "dynstat_theta_max"  "theta maximum"  $2 $3; yy=$? ;;            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
246             'Tav') testoutput_var $1 "dynstat_theta_mean" "theta mean"     $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
247             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "theta s.d."     $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
248             'Smn') testoutput_var $1 "dynstat_salt_min"  "salt minimum"    $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
249             'Smx') testoutput_var $1 "dynstat_salt_max"  "salt maximum"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
250             'Sav') testoutput_var $1 "dynstat_salt_mean" "salt mean"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
251             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "salt s.d."       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
252               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
253               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
254             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
255             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
256             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
257             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U s.d."          $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
258             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
259             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
260             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
261             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V s.d."          $2 $3; yy=$? ;;             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
262          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
263             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
264          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
# Line 294  testoutput_run() Line 266  testoutput_run()
266          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
267             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
268          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
269             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_sd"    $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
270             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
271             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
272             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
273             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
274             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
275             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
276             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
277             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
278             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
279             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
280             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
281             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
282            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
283            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
284            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
285            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
286            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
287            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
288                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
289            esac            esac
290            if test $xx = $sVar            if test $xx = $sVar
# Line 304  testoutput_run() Line 294  testoutput_run()
294          done          done
295    
296          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
297          if [ $nbVar -lt $nbDef ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
298          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
299            adNul=`expr $nbDef - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
300            echo $allargs $adNul            echo $allargs $adNul
301          else          else
302            echo $allargs            echo $allargs
303          fi          fi
304    # <-- same processing for adjoint & forward test
     else  
         testoutput_ad $1 $2 "precision_grdchk_result"  
     fi  
305  }  }
306    
307  genmakemodel()  genmakemodel()
# Line 342  genmakemodel() Line 329  genmakemodel()
329              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
330                  command="$command -ieee"                  command="$command -ieee"
331              fi              fi
332                if test "x$GSL" = xt ; then
333                    command="$command -gsl"
334                fi
335              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
336                  command="$command -mpi"                  command="$command -mpi"
337              fi              fi
# Line 414  run_clean() Line 404  run_clean()
404              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
405              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
406              rm -rf mnc_test_*              rm -rf mnc_test_*
407                rm -f *_MIT_CE_000.opt0000 costfunction*0000
408              echo successful 1>&2              echo successful 1>&2
409              exit 0              exit 0
410          )          )
# Line 484  symlink_mpifiles() Line 475  symlink_mpifiles()
475      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
476            
477      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
478      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
479    
480      #  Is this an MPI run?      #  Is this an MPI run?
481      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 542  linkdata() Line 533  linkdata()
533                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
534                  fi                  fi
535              fi              fi
536                prevDir='NONE'
537              for ldir in $* ; do              for ldir in $* ; do
538                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
539                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
540                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
541                      for i in $files ; do                      for i in $files ; do
# Line 559  linkdata() Line 551  linkdata()
551                      fi                      fi
552                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
553                  fi                  fi
554                    prevDir=$ldir
555              done              done
556          )          )
557      fi      fi
# Line 575  runmodel() Line 568  runmodel()
568          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
569          # make output.txt          # make output.txt
570          echo          echo
571            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
572                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
573                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi
574            fi
575          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
576              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
577              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
# Line 586  runmodel() Line 583  runmodel()
583                  RETVAL=8                  RETVAL=8
584                  ENDVAL=-1                  ENDVAL=-1
585          else          else
586              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
587                  # output do not exist or is older than executable:
588                  rm -f run.log ; touch run.log                  rm -f run.log ; touch run.log
589                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
590                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> run.log 2>&1
# Line 628  createcodelet() Line 626  createcodelet()
626  {  {
627      # create codelet for comparing model output      # create codelet for comparing model output
628    
629      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
630      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
631  #include <stdio.h>  #include <stdio.h>
632  #include <math.h>  #include <math.h>
# Line 637  int main( int argc, char** argv )  { Line 635  int main( int argc, char** argv )  {
635    double a,b,abave,relerr;    double a,b,abave,relerr;
636    best = -22;    best = -22;
637    lncnt = 0;    lncnt = 0;
638    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
639      scanf("%d", &linnum);      scanf("%d", &linnum);
640      if (linnum == -1)  break;      if (linnum == -1)  break;
641      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 684  formatresults() Line 682  formatresults()
682      listPrt=$@      listPrt=$@
683      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
684      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
685      printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'      printf '%3s' $listPrt
686  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > / /' | sed 's/  < / /'  #   line below does not work on hp-ux_ia64 : do those substitutions later on
687    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
688            
689      if [ $xx = '..' ]; then      if [ $xx = '..' ]; then
690          printf ' N/O '          printf ' N/O '
# Line 709  scandirs() Line 708  scandirs()
708  {  {
709      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
710          for arg in * ; do          for arg in * ; do
711              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
712          done          done
713      else      else
714          echo $*          echo $*
# Line 724  scandirs() Line 723  scandirs()
723  debug=0  debug=0
724  verbose=1  verbose=1
725  clean=0  clean=0
 expts=''  
 # ieee=1  
726    
727  IEEE=true  IEEE=true
728  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
729      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
730  fi  fi
731    GSL=f
732    
733  CLEANUP=f  CLEANUP=f
734  QUICK=f  QUICK=f
# Line 861  for ac_option ; do Line 858  for ac_option ; do
858    
859          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
860          -noieee) IEEE= ;;          -noieee) IEEE= ;;
861            -gsl) GSL=t ;;
862    
863          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
864          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 894  if test "x$QUICK" = xt ; then Line 892  if test "x$QUICK" = xt ; then
892      NODEPEND=t      NODEPEND=t
893  fi  fi
894    
895    #- setting for forward or ADM testing
896    if test "x$ADM" = xt ; then
897        code_dir=code_ad
898        inputdir=input_ad
899        ref_outp="output_adm.txt"
900        EXECUTABLE="mitgcmuv_ad"
901    else
902        code_dir=code
903        inputdir=input
904        ref_outp="output.txt"
905        EXECUTABLE="mitgcmuv"
906    fi
907    
908  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
909      if test "x$ADM" = xt ; then      LIST=`scandirs results/$ref_outp`
         LIST=`scandirs results_ad`  
     else  
         LIST=`scandirs results`  
     fi  
910  else  else
911      #- expand group of experiments:      #- expand group of experiments:
912      LIST=" "      LIST=" "
# Line 943  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 950  if test "x$OPTFILE" = xNONE -a "x$MITGCM
950      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
951  fi  fi
952    
953  if test "x$ADM" = xt ; then  OUTPUTFILE=$ref_outp
     EXECUTABLE="mitgcmuv_ad"  
     OUTPUTFILE="output_adm.txt"  
 else  
     EXECUTABLE="mitgcmuv"  
     OUTPUTFILE="output.txt"  
 fi  
   
954  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
955      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
956  fi  fi
# Line 958  if test "x$MPI" = xt ; then Line 958  if test "x$MPI" = xt ; then
958      OUTPUTFILE="STDOUT.0000"      OUTPUTFILE="STDOUT.0000"
959  fi  fi
960    
 #echo "OK"  
961  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
962    
963  # set the Default List of output variables to be checked:  # set the Default List of output variables to be checked:
964  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
965  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
966  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
967  if test "x$ADM" != xt ; then  if test "x$ADM" = x ; then
968      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
969      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
970      nbDef=`echo $DEF_CHECK_LIST | awk '{print NF-1+3*gsub("+","E")}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
971      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
972      EMPTY_RESULTS=$EMPTY_RESULTS`expr $nbDef - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
973    else
974        DEF_CHECK_LIST='Grad Cost Grad'
975        EMPTY_RESULTS='.. ..'
976        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
977  fi  fi
978    
979  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
980  createcodelet  createcodelet
981    
982  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
983  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
984      echo "skipping mpack build"      echo "skipping mpack build"
985  else  else
986      build_mpack      build_mpack
987  fi  fi
988    
989  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
990    CMDLINE=$0
991    for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
992  MACH=`hostname`  MACH=`hostname`
993  UNAMEA=`uname -a`  UNAMEA=`uname -a`
994  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 1004  if test "x$RETVAL" != x0 ; then Line 1009  if test "x$RETVAL" != x0 ; then
1009      exit 1      exit 1
1010  fi  fi
1011  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1012  start_date=`date`  start_date=`date`
1013  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1014    echo 'run:' $CMDLINE >> $SUMMARY
1015    echo 'on :' $UNAMEA  >> $SUMMARY
1016    
1017  of_path=  of_path=
1018  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1064  if test "x$ADM" = x ; then Line 1070  if test "x$ADM" = x ; then
1070  else  else
1071      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1072      echo >> $SUMMARY      echo >> $SUMMARY
1073        if [ $MATCH_CRIT -lt 10 ] ;
1074        then line_0="default     "$MATCH_CRIT ;
1075        else line_0="default    "$MATCH_CRIT ; fi
1076        echo "$line_0" | tee -a $SUMMARY
1077      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1078  G D M    C  G  G D M    C  G
1079  E p a R  o  r  E p a R  o  r
# Line 1076  fi Line 1086  fi
1086  #  ...and each test directory...  #  ...and each test directory...
1087  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1088            
1089        # set builddir & rundir:
1090        builddir="build"
1091        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1092        rundir="run"
1093        if test ! -d $dir/$rundir ; then
1094            rundir=$builddir
1095        fi
1096        CODE_DIR=$dir/$code_dir
1097        BUILD_DIR=$dir/$builddir
1098    
1099      #  Cleanup only!      #  Cleanup only!
1100      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1101          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1102              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/build
1103              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1104          fi          fi
1105          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1106              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1107              run_clean $dir/run              run_clean $dir/$rundir
1108          fi          fi
1109          (          (
1110              cd $dir              cd $dir
# Line 1095  for dir in $TESTDIRS ; do Line 1115  for dir in $TESTDIRS ; do
1115    
1116      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1117      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1118      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1119      if test ! -r $fout ; then      if test ! -r $fout ; then
1120          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1121          continue          continue
# Line 1111  for dir in $TESTDIRS ; do Line 1126  for dir in $TESTDIRS ; do
1126    
1127      # Check for additional types of monitor output      # Check for additional types of monitor output
1128    
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
   
1129      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1130          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1131          continue          continue
# Line 1141  for dir in $TESTDIRS ; do Line 1137  for dir in $TESTDIRS ; do
1137    
1138      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1139      extra_runs=      extra_runs=
1140      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1141          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1142          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1143          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1144              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1145              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1146              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1147                  if test "x$MULTI_THREAD" = "xt" ; then              if test "x$MULTI_THREAD" = "xt" ; then
1148                      if test -r $dir"/"$exd"/eedata.mth" ; then                  if test -r $dir"/"$exd"/eedata.mth" ; then
                         extra_runs="$extra_runs $name"  
                     #else echo $dir"/"$exd"/eedata.mth: not found"  
                     fi  
                 else  
1149                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1150                    #else echo $dir"/"$exd"/eedata.mth: not found"
1151                  fi                  fi
1152                else
1153                    extra_runs="$extra_runs $name"
1154              fi              fi
1155          done          fi
1156      fi      done
1157    
1158      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1159      echo      echo
# Line 1187  for dir in $TESTDIRS ; do Line 1182  for dir in $TESTDIRS ; do
1182              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1183              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1184              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1185              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1186              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1187              && results=`testoutput_run $dir $rundir "txt"`              && results=`testoutput_run $dir $rundir $ref_outp`
1188      fi      fi
1189            
1190      echo      echo
     if test "x$ADM" = x ; then  
1191          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1192          echo          echo
1193          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1194          touch $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1195          echo "fresults='$fres'" >> $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1196          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1197          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1198          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1199          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1200            if test "x$ADM" = xt ; then
1201                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1202                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1203                                    >> $CDIR"/summary.txt"
1204            fi
1205    
1206          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1207              unset run              unset run
1208              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1209                #  reference output file
1210                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1211              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1212              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1213              mkdir $rel_CDIR              mkdir $rel_CDIR
1214              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1215              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1216              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1217              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1218              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1219                  && results=`testoutput_run $dir tr_run.$ex ${ex}".txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1220              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1221              fres="$fres.$ex"              fres="$fres.$ex"
1222              echo              echo
1223              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1224              touch $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1225              echo "fresults='$fres'" >> $CDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1226              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1227              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1228              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1229              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1230                if test "x$ADM" = xt ; then
1231                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1232                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1233                                       >> $CDIR"/summary.txt"
1234                fi
1235              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1236                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1237              fi              fi
1238          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         touch $CDIR"/summary.txt"  
         echo "fresults='$fres'" >> $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1239    
1240      #postclean $dir/$builddir      #postclean $dir/$builddir
1241      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1291  fi Line 1282  fi
1282  rm -f tr_cmpnum.c tr_cmpnum  rm -f tr_cmpnum.c tr_cmpnum
1283    
1284  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1285      cat $SUMMARY | sed 's/  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.//'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
 #   cat $SUMMARY | sed 's/  \.//g'  
1286      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1287          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1288      fi      fi
1289      cat $SUMMARY | sed 's/  \.//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1290  fi  fi
1291    
1292  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.94  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.22